Unit SF52R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF14_p, SF53R_p, SF49R_p;

function SF52R(X :Real; Y :Real; RHO :Real; var IERR :Integer): Real;

implementation

function SF52R(X :Real; Y :Real; RHO :Real; var IERR :Integer): Real;
var
IAX,IAY,IND :Integer;
C0,F1,XY,AX,AY,TY,TX,QX,QY :Real;
const
SYS093 :Real = 0.999999;
SYS059 :Real = 3.4E38;
SYS089 :Real = 1.0E-6;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
{ Result -    SF52R  FORTRANe }
C0 := Sqrt(0.5);
IERR := 0;
if ( Abs(RHO) < SYS093 ) 
 then goto _1;
IERR := 65;
Result := SYS059;
goto _10;
_1:
F1 := 1.0/Sqrt(1.0-RHO*RHO);
XY := X*Y;
IAX := 0;
IAY := 0;
IND := 0;
if ( XY = 0.0 ) 
 then goto _2;
AX := F1*(Y/X-RHO);
AY := F1*(X/Y-RHO);
goto _5;
_2:
if ( X <> 0.0 ) 
 then goto _3;
if ( Y <> 0.0 ) 
 then goto _4;
AX := F1*(1.0-RHO);
AY := AX;
goto _5;
_3:
TY := 0.25;
if ( X < 0.0 ) 
 then TY := -TY;
AX := -F1*RHO;
IND := 1;
goto _5;
_4:
TX := 0.25;
if ( Y < 0.0 ) 
 then TX := -TX;
AY := -F1*RHO;
goto _7;
_5:
if ( AX >= 0.0 ) 
 then goto _6;
IAX := 1;
AX := -AX;
_6:
TX := SF53R(X,AX,SYS089);
if ( IAX <> 0 ) 
 then TX := -TX;
if ( IND <> 0 ) 
 then goto _9;
_7:
if ( AY >= 0.0 ) 
 then goto _8;
IAY := 1;
AY := -AY;
_8:
TY := SF53R(Y,AY,SYS089);
if ( IAY <> 0 ) 
 then TY := -TY;
_9:
QX := SF49R(X);
QY := SF49R(Y);
Result := 0.5*(QX+QY)-TX-TY;
if ( (XY <= 0.0) ) and ( ((XY <> 0.0) ) or ( (X+Y < 0.0)) )
 then Result := Result-0.5;
Result := EMin1(EMax1(0.0,Result),1.0);
_10:
if ( IERR <> 0 ) 
 then UTSF14(IERR,52);
exit;
end;

end.
